class GaussianElimination
  def initialize
    @mat = nil
    @dimension = 0
    @solve = nil
  end
  
  def solve(*arrays)
    @mat = arrays
    @dimension = @mat.size
    return "Dimension Error" if @dimension != @mat[0].size - 1
    @solve = Array.new(@dimension)
    return "Solve Error" unless forward_elimination
    backward_substitution
    return @solve
  end
  
  def forward_elimination
    0.upto(@dimension-1) do |i|
      nextto = true
      @mat[i+1..-1].each{|line| if line[i] != 0 then nextto = false; break end}
      if nextto
        return false if @mat[i][i] == 0.0
        next
      end
      select_pivot(i)
      a = @mat[i][i]
      @mat[i+1..-1].each do |line|
        s = line[i] / a.to_f
        line[i] = 0.0
        (i+1).upto(@dimension) do |j|
          line[j] -= s * @mat[i][j]
        end
      end
    end
    return true
  end
  
  def backward_substitution
    (@dimension - 1).downto(0) do |i|
      @solve[i] =  @mat[i][-1]
      (@dimension - 1).downto(i+1) do |j|
        @solve[i] -= @mat[i][j] * @solve[j]
      end
      @solve[i] /= @mat[i][i].to_f
    end
  end
  
  def select_pivot(i)
    index = @mat.index(@mat[i..-1].max{|line1, line2| line1[i] <=> line2[i]})
    return if i == index
    @mat[i],@mat[index] = @mat[index],@mat[i]
  end
end

ge = GaussianElimination.new
r1 = [5,2,0,9]
r2 = [1,4,2,15]
r3 = [6,1,4,20]
p ge.solve(r1,r2,r3)
